<template>
  <!--article detail page-->
  <div>
    <div class="detail-container">
      <div class="detail-header-image">
        <img :src="image" :alt="details.image_alt_info">
      </div>
      <div class="column">    
        <h1 class="h1-class">{{ details.title }}</h1> 
        <div class="date">{{ toDate }}</div> 
      </div>
      <!--start content section -->
      <div class="row columns">    
        <div class="detail-content has-intro" v-html="details.content"></div>
        <!-- Remove this section after the details content has its own <div class="inner-card-marker"></div> -->
        <div class="detail-content has-intro" >
          <p>Adipisci id eum et fugit suscipit expedita. Earum in et harum sed. Cum voluptatem itaque sunt. Velit ut quibusdam quia nisi cum. Maxime ipsa animi ut soluta non expedita.</p><p>Ea error quasi est a eveniet omnis. In in consectetur. Occaecati nam delectus voluptatum rerum. Architecto aliquid vitae. Quod perspiciatis vero pariatur maiores quis ut esse quod.</p><div class="inner-card-marker"></div><p>Adipisci sed vel optio sit sunt impedit error veniam. Sit labore temporibus. Nam sit saepe odio. Voluptatem asperiores tenetur fugit quia. Repellendus iure sapiente beatae repudiandae id.</p><img src="http://localhost:2223/880/902">Sed omnis et voluptatem. Officiis molestias sunt sed sit. Voluptatibus laboriosam at unde. Consequatur nihil consequuntur soluta accusamus praesentium<p></p><p>Magni ipsam dicta id culpa doloribus. Blanditiis et aliquid ex quibusdam consectetur animi. Maiores neque excepturi maxime est sunt perferendis enim veritatis. Magni rerum autem nemo asperiores sit vitae eaque. Doloremque atque sint est et excepturi. Ratione praesentium rerum aut in repellat.</p><div class="inner-card-marker"></div><p>Atque voluptatem voluptatem accusantium totam. Perferendis est suscipit sint. Earum atque aperiam. Sed incidunt perspiciatis repellat vel debitis cum occaecati eum. In voluptate sit velit. Reiciendis vero odit aspernatur deserunt facilis.</p><div class="inner-card-marker"></div><p>Eum aut aliquam illum vitae et dignissimos eius fugiat optio. Magnam et voluptatem voluptatibus rerum qui qui repellendus. Veniam autem impedit assumenda quia ut. Modi quae iste quibusdam enim impedit nam voluptatem id.</p>
        </div>
        <stats :stats="stat" />
     </div>
    </div>
    <div class="row column detail-footer">
        <social-share :stats="stat" />
      <div class="detail-related">
        <flex-card v-for="item in details.related.footer" :key="item" :card="item" />
      </div>
      <div class="cta-swipe">
        Sayfayı sağa sola kaydırarak diğer haberlere geçebilirsiniz.
        <div class="cta-swipe-gesture">
          <img src="~assets/img/one-finger-swipe-left-right.png" alt="">
        </div>
      </div>
    </div>
    <div class="detail-inner">
      <div class="detail-related">
        <flex-card v-for="inner in details.related.inner" :key="inner" :card="inner" />
      </div>
    </div>

    </div>
  </div>
</template>

<script>
import axios from 'axios'
import apiRoutes from '~components/apiRoutes.js'

import Stats from '~components/detail/stats'
import socialShare from '~components/detail/socialShare'
import flexCard from '~components/flexCard'
// import { mapState } from 'vuex'
import { mapMutations } from 'vuex'
const apiEndPoint = apiRoutes.detail_article
const dateFormat = { weekday: 'long', year: 'numeric', month: 'long', day: 'numeric' }

export default {
  validate ({ store, params }) { // SHAME Check url params before if it exists in state, if not fetch it
    // console.log('validate:', params, store)
    // let slut = params.slug
    // Check if `params.slug` is an existing details
    // return (isNaN(params.slug) && (!!params.slug))
    return true
  },
  fetch ({ store, params }) {
    console.log('async fetch init', params.slug)
    return store.dispatch('details/LOAD_DETAIL', params.slug)
  },
  asyncData ({ params, error, store }) { // fallback if the state is empty and url is directly reached
    // console.log('context', store, apiEndPoint)
    if (Object.keys(store.state.details.list).some(checkThisKeyisSlug => checkThisKeyisSlug === params.slug)) {
      // key exists in the store do nothing
    } else { // key not exists in the store make another request
      // console.log('storeeee', store.state.details.list)
      // store.dispatch('details/LOAD_DETAIL', params.slug)
      return axios.get(apiEndPoint + `${params.slug}`)
      .then((res) => {
        return { details: res.data[0] }
        // when you query with slug, response is an array, result is the first
      })
      .catch(() => {
        error({ message: 'Error in getting the details', statusCode: 404 })
      })
    }
  },
  computed: {
    details () {
      // return this.$store.state.details.list['tempora-rerum-dignissimos-ipsam-enim-quo-molestiae-animi-mollitia']
      return this.$store.state.details.list[this.$route.params.slug]
    },
    image () {
      return this.details.image_url // image_url2x TODO write a condition for responsive systems
    },
    toDate () {
      return (!this.details.date) ? '' : new Date(this.details.date).toLocaleDateString('tr-TR', dateFormat)
    },
    stat () {
      return this.details.stat
    },
    topBarSettings () {
      return { // copy me to every page with setTopbarSettings actions
        pageTitle: 'BIHABER',
        // pageTitle: this.details.title,
        topbarMenu: {
          isBackIconVisible: true,
          isCardToggleIconVisible: false,
          isFilterIconVisible: false,
          isSearchIconVisible: true,
          isSettingsIconVisible: false,
          isAddFavoritesIconVisible: false
        }
      }
    }
  },
  created () {
    this.closeSidebar()
  },
  beforeMount () {
    this.setTopbarSettings()
  },
  mounted () {
    this.$nextTick(() => {
      if (this.details.related.inner) {
        this.moveInnerRelateds()
        window.addEventListener('resize', this.moveInnerRelateds)
      }
    })
  },
  methods: {
    // this method moves the cars to their places and matches content count with markers. If there is a mismatch it fixes it.
    moveInnerRelateds () {
      console.log('related.inner cards moving')
      let innerCardMarkers = document.querySelectorAll('.inner-card-marker')
      let innerCards = document.querySelector('.detail-inner .detail-related')

      // move the cards to marker position
      innerCardMarkers.forEach((node, index) => {
        if (node && index < innerCards.children.length) { // check if there is a mismatch between marker counts
          innerCards.childNodes[index].style.top = `${node.offsetTop}px`
        } else if (node && index >= innerCards.children.length) {
          // console.log('remove unneccesary marker node')
          node.style.display = `none`
        }
        // console.log('inner-card-markerpos', node.offsetTop)
      })
    },
    setTopbarSettings () {
      this.$store.commit('pushTopBarLayout', this.topBarSettings.topbarMenu)
      this.$store.dispatch('SET_PAGE_TITLE', this.topBarSettings.pageTitle)
    },
    ...mapMutations({
      closeSidebar: 'closeSidebar'
    })
  },
  beforeDestroy () {
    window.removeEventListener('resize', this.handleResize)
  },
  components: {
    Stats,
    flexCard,
    socialShare
  }
}
</script>
